﻿using Nancy.Authentication.Basic;
using Nancy;

namespace AgbaraVOIP.Rest
{
    public class AuthenticationBootstrapper : DefaultNancyBootstrapper
    {
        protected override void InitialiseInternal(TinyIoC.TinyIoCContainer container)
        {
            base.InitialiseInternal(container);

            this.EnableBasicAuthentication(new BasicAuthenticationConfiguration(
                container.Resolve<IUserValidator>(),
                "MyRealm"));
        }
        
    }
}
